<?php

namespace EventPortal\Domain\Delegate\Handlers;

use Closure;
use EventPortal\Domain\Delegate\Models\Delegate;
use EventPortal\Domain\Form\Payload;

class CreateOrUpdateDelegate
{
    /**
     * @return mixed
     */
    public function __invoke(Payload $payload, Closure $next)
    {
        $payload->addToInput(['user_id' => $payload->getModel()->id]);

        $delegate = Delegate::updateOrCreate(
            ['user_id' => $payload->getModel()->id],
            $payload->getInput()
        );

        $payload->addContext('delegate', $delegate);

        return $next($payload);
    }
}
