<?php

namespace EventPortal\Tests\Support\Assertions;

use Illuminate\Support\Arr;
use PHPUnit\Framework\Assert;

class PropAssertions
{
    public function props()
    {
        return function ($key = null) {
            $props = json_decode(json_encode($this->original->getData()['page']['props']), JSON_OBJECT_AS_ARRAY);

            if ($key) {
                return Arr::get($props, $key);
            }

            return $props;
        };
    }

    public function assertHasProp()
    {
        return function ($key = null) {
            Assert::assertTrue(Arr::has($this->props(), $key), "Does not have prop '{$key}'.");
        };
    }

    public function assertPropValue()
    {
        return function ($key, $value) {
            $this->assertHasProp($key);

            if (is_callable($value)) {
                $value($this->props($key));
            } else {
                Assert::assertEquals($this->props($key), $value);
            }
        };
    }

    public function assertPropCount()
    {
        return function ($key, $count) {
            $this->assertHasProp($key);

            Assert::assertCount($count, $this->props($key));
        };
    }
}
